"use strict";
{
    self.C3.Plugins.EMI_INDO_Ultimate_Camera.Acts = {
        Optimis(x, y, width, height)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            const ops = {
                x: x,
                y: y,
                width: width,
                height: height,
                camera: CameraPreview.CAMERA_DIRECTION.BACK,
                tapPhoto: self.tapphoto,
                previewDrag: self.previewdrag,
                toBack: self.toback,
                tapFocus: self.tapfocus,
                storeToFile: self.storetofile,
                disableExifHeaderStripping: self.disableexifheader

            };

            this.EMI_INDO.startCamera(ops, success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Camera);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Error);
            }


        },

        Putar()
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.switchCamera(success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Putar);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Error);

            }

        },

        Stopcamera()
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.stopCamera(success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Stop);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Error);
            }


        },

        Show()
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.show(success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Show);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Error);
            }


        },

        Hide()
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.hide(success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Hide);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Error);
            }


        },

        Takepicture(a, b, c, d)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            var imageData = {

                width: a,
                height: b,
                quality: c,
                filepath: d

            };

            this.EMI_INDO.takePicture(success, fail, function(imageData)
            {

                });

            function success(imageData)
            {

                self.eventResponse = (imageData);
                self.Trigger(self.ins.Takepicture);
            }

            function fail(result)
            {
                self.errorResponse = (result);
                self.Trigger(self.ins.Error);

            }



        },

        Takesnapshot(quality)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            function success(result)
            {

                self.eventResponse = (result);
                self.Trigger(self.ins.Takesnapshot);
            }

            function fail(result)
            {
                self.errorResponse = (result);
                self.Trigger(self.ins.Error);
            }

            this.EMI_INDO.takeSnapshot(
            {
                quality: quality
            }, success, fail, function(base64PictureData)
            {

                });
        },

        Setcoloreffect(eff)
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            this.EMI_INDO.setColorEffect(CameraPreview.COLOR_EFFECT = eff, success, fail);
        },

        Setflashmode(rh)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }
            this.EMI_INDO.setFlashMode(CameraPreview.FLASH_MODE = rh, success, fail);

        },

        Startrecordvideo(p, w, x, y, fp)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            var opt = {
                cameraDirection: CameraPreview.CAMERA_DIRECTION.BACK,
                width: p,
                height: w,
                quality: x,
                withFlash: y
            }

            this.EMI_INDO.startRecordVideo(opt, success, fail, function(fp)
            {

                });

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Startrecordvideo);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

        },

        Stoprecordvideo(filePath)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            this.EMI_INDO.stopRecordVideo(success, fail, function(filePath)
            {

                });

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Stoprecordvideo);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

        },

        Setpreviewsize(w, h)
        {
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.setPreviewSize(
            {
                width: w,
                height: h,
                success,
                fail
            });

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }
        },

        Setzoom(zom)
        {
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            this.EMI_INDO.setZoom(zom, success, fail);


            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

        },

        Costum(x, y, width, height, camerax, toBack, tapPhoto, tapFocus, previewDrag, storeToFile, disableExifHeaderStripping)
        {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {
                const ops = {
                    x: x,
                    y: y,
                    width: width,
                    height: height,
                    camera: CameraPreview.CAMERA_DIRECTION = camerax,
                    tapPhoto: tapPhoto,
                    previewDrag: previewDrag,
                    toBack: toBack,
                    tapFocus: tapFocus,
                    previewDrag: previewDrag,
                    storeToFile: storeToFile,
                    disableExifHeaderStripping: disableExifHeaderStripping,
                    backgroundcolor: 'transparent'

                };

                this.EMI_INDO.startCamera(ops, success, fail);

                function success(result)
                {
                    self.eventResponse = (result);
                    self.Trigger(self.ins.Camera);
                }

                function fail(result)
                {
                    self.eventResponse = (result);
                    self.Trigger(self.ins.Error);
                }

            }
        },

        Setwhitebalancemode(wbm)
        {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            this.EMI_INDO.setWhiteBalanceMode(CameraPreview.WHITE_BALANCE_MODE = wbm, success, fail);
        },

        Taptofocus(x, y)
        {
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            const self = this;
            let xPoint = event = x;
            let yPoint = event = y
            this.EMI_INDO.tapToFocus(xPoint, yPoint, success, fail);


            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

        },

        Setexposuremode(exp)
        {
            if (typeof window['CameraPreview'] == 'undefined')
            {
                return;
            }
            else
            {};
            const self = this;
            this.EMI_INDO.setExposureMode(CameraPreview.EXPOSURE_MODE = exp, success, fail);

            function success(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

            function fail(result)
            {
                self.eventResponse = (result);
                self.Trigger(self.ins.Response);
            }

        }
    };
}